package com.goldencode.testcases;

import com.goldencode.p2j.util.*;
import com.goldencode.p2j.persist.*;
import com.goldencode.testcases.dmo.vtest.*;

import static com.goldencode.p2j.util.BlockManager.*;

/**
 * Business logic (converted to Java from the 4GL source code
 * in Vadim22.p).
 */
public class Vadim22
{
   Btest.Buf btest = RecordBuffer.define(Btest.Buf.class, "vtest", "btest");

   Btest.Buf hbuffer = RecordBuffer.define(Btest.Buf.class, "vtest", "hbuffer");

   final QueryWrapper query0 = new QueryWrapper(false);

   /**
    * External procedure (converted to Java from the 4GL source code
    * in Vadim22.p).
    */
   public void execute()
   {
      externalProcedure(new Block()
      {
         logical log = new logical(false);

         integer int1 = new integer(0);

         handle hBuffer = new handle();

         handle hQuery = new handle();

         handle hBuffer1 = new handle();

         handle hBuf = new handle();

         character ch = new character("");

         handle hField = new handle();

         rowid r = new rowid();

         integer lock = new integer(0);

         integer nowait = new integer(0);

         public void init()
         {
            TransactionManager.register(log, int1, hBuf, r);
         }

         public void body()
         {
            RecordBuffer.openScope(btest, hbuffer);
            UnnamedStreams.assignOut(StreamFactory.openFileStream("vadim22_results", true, false));
            hBuf.assign(hbuffer);
            /*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ tests for attributes
            ~~~~~~~~~~~~~~~~~~~~~*/
            log.assign(((Buffer) hBuffer.get()).error());
            ((Buffer) hBuffer.get()).changeError(log);
            ch.assign(((Buffer) hBuffer.get()).format());
            ((Buffer) hBuffer.get()).changeFormat(ch);
            ((Buffer) hBuffer.get()).value();
            ((Buffer) hBuffer.get()).changeValue(((Buffer) hBuffer.get()).value(2));
            ((Buffer) hBuffer.get()).changeValue(1, ((Buffer) hBuffer.get()).value(2));
            ((Buffer) hBuffer.get()).changeValue(((Buffer) hBuf.get()).value());
            hField.assign(((Buffer) hBuffer.get()).bufferField(5));
            int1.assign(((FieldReference) hField.get()).extent());
            log.assign(((P2JQuery) hQuery.get()).getNumResults());
            /*log = hQuery:NUM-BUFFERS.*/
            log.assign(((Buffer) hQuery.get()).numFields());
            log.assign(((Buffer) hBuffer.get()).rowId());
            ch.assign(((Buffer) hBuffer.get()).columnLabel());
            ((Buffer) hBuffer.get()).changeColumnLabel(ch);
            log.assign(((Buffer) hBuffer.get()).characterLocked());
            ch.assign(((Buffer) hBuffer.get()).stringValue());
            ch.assign(((Buffer) hBuffer.get()).stringValue(1));
            ch.assign(((Buffer) hBuffer.get()).initial());
            log.assign(((Buffer) hBuffer.get()).ambiguous());
            new FindQuery(hbuffer, "'CUSTNUM = 15'", null, "hbuffer.id asc").first();
            /*
            **                  BUFFER-COPY (KW_BUF_COPY)
            **                  BUFFER-COMPARE (KW_BUF_COMP)
            **                  BUFFER-FIELD (KW_BUF_FLD)
            **                  BUFFER-RELEASE (KW_BUF_REL)
            **                  FIND-BY-ROWID (KW_FIND_BR)
            **                  FIND-CURRENT (KW_GET_CUR)
            **                  FIND-UNIQUE (KW_GET_UNI)
            **                  FIND-FIRST (KW_FIND_1ST)
            **                  FIND-LAST (KW_FIND_LST)
            **                  GET-BUFFER-HANDLE (KW_GET_BUFH)
            */
            hbuffer.release();
            log.assign(((Buffer) hBuffer.get()).bufferField(1));
            log.assign(((Buffer) hBuffer.get()).bufferField("aaa"));
            log.assign(((Buffer) hBuffer.get()).bufferCopy(hBuffer1));
            /*lock = SHARE-LOCK.
            nowait = NO-WAIT.*/
            log.assign(((Buffer) hBuffer.get()).findFirst("CustNum = 5", LockType.LT_EXCLUSIVE, LockType.LT_NO_WAIT));
            log.assign(((Buffer) hBuffer.get()).findFirst("CustNum = 5", LockType.LT_SHARE, LockType.LT_NO_WAIT));
            log.assign(((Buffer) hBuffer.get()).findFirst("CustNum = 5", LockType.LT_NONE, LockType.LT_NO_WAIT));
            log.assign(((Buffer) hBuffer.get()).findFirst("CustNum = 5", LockType.LT_EXCLUSIVE));
            log.assign(((Buffer) hBuffer.get()).findFirst("CustNum = 5", LockType.LT_SHARE));
            log.assign(((Buffer) hBuffer.get()).findFirst("CustNum = 5", LockType.LT_NONE));
            log.assign(((Buffer) hBuffer.get()).findFirst("CustNum = 5", LockType.LT_EXCLUSIVE, nowait));
            log.assign(((Buffer) hBuffer.get()).findFirst("CustNum = 5", LockType.LT_SHARE, nowait));
            log.assign(((Buffer) hBuffer.get()).findFirst("CustNum = 5", LockType.LT_NONE, nowait));
            log.assign(((Buffer) hBuffer.get()).findFirst("CustNum = 5", lock, LockType.LT_NO_WAIT));
            log.assign(((Buffer) hBuffer.get()).findFirst("CustNum = 5", LockType.LT_EXCLUSIVE, nowait));
            log.assign(((Buffer) hBuffer.get()).findFirst("CustNum = 5", lock, nowait));
            log.assign(((Buffer) hBuffer.get()).findLast("CustNum = 5", LockType.LT_EXCLUSIVE, LockType.LT_NO_WAIT));
            log.assign(((Buffer) hBuffer.get()).findLast("CustNum = 5", LockType.LT_SHARE, LockType.LT_NO_WAIT));
            log.assign(((Buffer) hBuffer.get()).findLast("CustNum = 5", LockType.LT_NONE, LockType.LT_NO_WAIT));
            log.assign(((Buffer) hBuffer.get()).findLast("CustNum = 5", LockType.LT_EXCLUSIVE));
            log.assign(((Buffer) hBuffer.get()).findLast("CustNum = 5", LockType.LT_SHARE));
            log.assign(((Buffer) hBuffer.get()).findLast("CustNum = 5", LockType.LT_NONE));
            log.assign(((Buffer) hBuffer.get()).findLast("CustNum = 5", LockType.LT_EXCLUSIVE, nowait));
            log.assign(((Buffer) hBuffer.get()).findLast("CustNum = 5", LockType.LT_SHARE, nowait));
            log.assign(((Buffer) hBuffer.get()).findLast("CustNum = 5", LockType.LT_NONE, nowait));
            log.assign(((Buffer) hBuffer.get()).findLast("CustNum = 5", lock, LockType.LT_NO_WAIT));
            log.assign(((Buffer) hBuffer.get()).findLast("CustNum = 5", LockType.LT_EXCLUSIVE, nowait));
            log.assign(((Buffer) hBuffer.get()).findLast("CustNum = 5", lock, nowait));
            log.assign(((Buffer) hBuffer.get()).findUnique("CustNum = 5", LockType.LT_EXCLUSIVE, LockType.LT_NO_WAIT));
            log.assign(((Buffer) hBuffer.get()).findUnique("CustNum = 5", LockType.LT_SHARE, LockType.LT_NO_WAIT));
            log.assign(((Buffer) hBuffer.get()).findUnique("CustNum = 5", LockType.LT_NONE, LockType.LT_NO_WAIT));
            log.assign(((Buffer) hBuffer.get()).findUnique("CustNum = 5", LockType.LT_EXCLUSIVE));
            log.assign(((Buffer) hBuffer.get()).findUnique("CustNum = 5", LockType.LT_SHARE));
            log.assign(((Buffer) hBuffer.get()).findUnique("CustNum = 5", LockType.LT_NONE));
            log.assign(((Buffer) hBuffer.get()).findUnique("CustNum = 5", LockType.LT_EXCLUSIVE, nowait));
            log.assign(((Buffer) hBuffer.get()).findUnique("CustNum = 5", LockType.LT_SHARE, nowait));
            log.assign(((Buffer) hBuffer.get()).findUnique("CustNum = 5", LockType.LT_NONE, nowait));
            log.assign(((Buffer) hBuffer.get()).findUnique("CustNum = 5", lock, LockType.LT_NO_WAIT));
            log.assign(((Buffer) hBuffer.get()).findUnique("CustNum = 5", LockType.LT_EXCLUSIVE, nowait));
            log.assign(((Buffer) hBuffer.get()).findUnique("CustNum = 5", lock, nowait));
            log.assign(((Buffer) hBuffer.get()).bufferRelease());
            log.assign(((Buffer) hBuffer.get()).findByRowId(r, LockType.LT_EXCLUSIVE, LockType.LT_NO_WAIT));
            log.assign(((Buffer) hBuffer.get()).findByRowId(r, LockType.LT_SHARE, LockType.LT_NO_WAIT));
            log.assign(((Buffer) hBuffer.get()).findByRowId(r, LockType.LT_NONE, LockType.LT_NO_WAIT));
            log.assign(((Buffer) hBuffer.get()).findByRowId(r, LockType.LT_EXCLUSIVE));
            log.assign(((Buffer) hBuffer.get()).findByRowId(r, LockType.LT_SHARE));
            log.assign(((Buffer) hBuffer.get()).findByRowId(r, LockType.LT_NONE));
            log.assign(((Buffer) hBuffer.get()).findByRowId(r, LockType.LT_EXCLUSIVE, nowait));
            log.assign(((Buffer) hBuffer.get()).findByRowId(r, LockType.LT_SHARE, nowait));
            log.assign(((Buffer) hBuffer.get()).findByRowId(r, LockType.LT_NONE, nowait));
            log.assign(((Buffer) hBuffer.get()).findByRowId(r, lock, LockType.LT_NO_WAIT));
            log.assign(((Buffer) hBuffer.get()).findByRowId(r, LockType.LT_EXCLUSIVE, nowait));
            log.assign(((Buffer) hBuffer.get()).findByRowId(r, lock, nowait));
            log.assign(((Buffer) hBuffer.get()).findByRowId(r));
            log.assign(((Buffer) hBuffer.get()).findByRowId(r, 444, nowait));
            log.assign(((Buffer) hBuffer.get()).bufferCompare(hBuffer1));
            log.assign(hbuffer.available());
            hBuffer.assign(((P2JQuery) hQuery.get()).bufferHandle(1));
            hBuffer.assign(((P2JQuery) hQuery.get()).bufferHandle("aaa"));
            query0.close();
            log.assign(((P2JQuery) hQuery.get()).queryClose());
            log.assign(((P2JQuery) hQuery.get()).queryForward(56));
            log.assign(((P2JQuery) hQuery.get()).queryReposition(r));
            log.assign(((P2JQuery) hQuery.get()).queryCurrent(LockType.LT_NONE));
            log.assign(((P2JQuery) hQuery.get()).queryCurrent(LockType.LT_SHARE, LockType.LT_NO_WAIT));
            log.assign(((P2JQuery) hQuery.get()).queryCurrent(LockType.LT_EXCLUSIVE, LockType.LT_NO_WAIT));
            log.assign(((P2JQuery) hQuery.get()).queryCurrent(lock));
            log.assign(((P2JQuery) hQuery.get()).queryCurrent(lock, LockType.LT_NO_WAIT));
            log.assign(((P2JQuery) hQuery.get()).queryCurrent(LockType.LT_SHARE, nowait));
            log.assign(((P2JQuery) hQuery.get()).queryCurrent(LockType.LT_EXCLUSIVE, nowait));
            log.assign(((P2JQuery) hQuery.get()).queryRepositionByID(btest.rowID()));
            log.assign(((P2JQuery) hQuery.get()).queryRepositionByID(btest.rowID(), btest.rowID()));
         }
      });
   }
}
